/*
 * This file was generated automatically by ExtUtils::ParseXS version 2.2206 from the
 * contents of ByteLoader.xs. Do not edit this file, edit ByteLoader.xs instead.
 *
 *	ANY CHANGES MADE HERE WILL BE LOST! 
 *
 */

#line 1 "ByteLoader.xs"
/* This loads bytecode in .plc files starting with PLBC.
   Produce by the B::Bytecode compiler.

   It might also be useful to use it for JIT or Asm compiled
   PLJC .plc files where a full PE/COFF or elf format is not
   supported nor wanted, jumps are not patched,
   or a full executable dump is not possible.
*/

#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"
#include "byterun.h"

/* Something arbitary for a buffer size */
#define BYTELOADER_BUFFER 8096

int
bl_getc(struct byteloader_fdata *data)
{
    dTHX;
    if (SvCUR(data->datasv) <= (STRLEN)data->next_out) {
      int result;
      /* Run out of buffered data, so attempt to read some more */
      *(SvPV_nolen(data->datasv)) = '\0';
      SvCUR_set(data->datasv, 0);
      data->next_out = 0;
      result = FILTER_READ(data->idx + 1, data->datasv, BYTELOADER_BUFFER);

      /* Filter returned error, or we got EOF and no data, then return EOF.
	 Not sure if filter is allowed to return EOF and add data simultaneously
	 Think not, but will bullet proof against it. */
      if (result < 0 || SvCUR(data->datasv) == 0)
	return EOF;
      /* Else there must be at least one byte present, which is good enough */
    }

    return *((U8 *) SvPV_nolen(data->datasv) + data->next_out++);
}

int
bl_read(struct byteloader_fdata *data, char *buf, size_t size, size_t n)
{
    dTHX;
    char *start;
    STRLEN len;
    size_t wanted = size * n;

    start = SvPV(data->datasv, len);
    if (len < (data->next_out + wanted)) {
      int result;

      /* Shuffle data to start of buffer */
      len -= data->next_out;
      if (len) {
	memmove(start, start + data->next_out, len + 1);
      } else {
	*start = '\0';	/* Avoid call to memmove. */
      }
      SvCUR_set(data->datasv, len);
      data->next_out = 0;

      /* Attempt to read more data. */
      do {
	result = FILTER_READ(data->idx + 1, data->datasv, BYTELOADER_BUFFER);
	
	start = SvPV(data->datasv, len);
      } while (result > 0 && len < wanted);
      /* Loop while not (EOF || error) and short reads */

      /* If not enough data read, truncate copy */
      if (wanted > len)
	wanted = len;
    }

    if (wanted > 0) {
      memcpy(buf, start + data->next_out, wanted);
      data->next_out += wanted;
      wanted /= size;
    }
    return (int) wanted;
}

static I32
byteloader_filter(pTHX_ int idx, SV *buf_sv, int maxlen)
{
    OP *saveroot = PL_main_root;
    OP *savestart = PL_main_start;
    struct byteloader_state bstate;
    struct byteloader_fdata data;
    int len;
    (void)buf_sv;
    (void)maxlen;

    data.next_out = 0;
    data.datasv = FILTER_DATA(idx);
    /* [perl #86186] Using tell(DATA) within __DATA__ file buffer is broken on Win32:
       Source filters were changed with 5.14 to read DATA in textmode, so \r\n are
       changed to \n on Windows only in our binary data.
     */
    PerlIO_binmode(aTHX_ PL_RSFP, IoTYPE_RDONLY, O_BINARY, 0);
    data.idx = idx;

    bstate.bs_fdata = &data;
    bstate.bs_obj_list = Null(void**);
    bstate.bs_obj_list_fill = -1;
    bstate.bs_sv = Nullsv;
    bstate.bs_iv_overflows = 0;

/* KLUDGE */
    /*  byterun loads incrementally from DATA, jitrun might require the whole
	buffer at once. best via mmap */
    if (byterun(aTHX_ &bstate)
        && (len = SvCUR(data.datasv) - (STRLEN)data.next_out))
    {
	PerlIO_seek(PL_RSFP, -len, SEEK_CUR);
	PL_RSFP = NULL;
    }
    filter_del(byteloader_filter);

    if (PL_in_eval) {
        OP *o;

        PL_eval_start = PL_main_start;

        o = newSVOP(OP_CONST, 0, newSViv(1));
        PL_eval_root = newLISTOP(OP_LINESEQ, 0, PL_main_root, o);
        PL_main_root->op_next = o;
        PL_eval_root = newUNOP(OP_LEAVEEVAL, 0, PL_eval_root);
        o->op_next = PL_eval_root;

        PL_main_root = saveroot;
        PL_main_start = savestart;
    }

    return 0;
}

#line 149 "ByteLoader.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(pTHX_ const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(pTHX_ const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
            Perl_croak(aTHX_ "Usage: %s::%s(%s)", hvname, gvname, params);
        else
            Perl_croak(aTHX_ "Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
        Perl_croak(aTHX_ "Usage: CODE(0x%"UVxf")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#ifdef PERL_IMPLICIT_CONTEXT
#define croak_xs_usage(a,b)	S_croak_xs_usage(aTHX_ a,b)
#else
#define croak_xs_usage		S_croak_xs_usage
#endif

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#line 201 "ByteLoader.c"

XS(XS_ByteLoader_import); /* prototype to pass -Wmissing-prototypes */
XS(XS_ByteLoader_import)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	char *	package;
#line 147 "ByteLoader.xs"
    SV *sv = newSVpvn ("", 0);
#line 218 "ByteLoader.c"

	if (items < 1)
	    package = "ByteLoader";
	else {
	    package = (char *)SvPV_nolen(ST(0));
	}
#line 149 "ByteLoader.xs"
    if (!sv)
      croak ("Could not allocate ByteLoader buffers");
    filter_add(byteloader_filter, sv);
#line 229 "ByteLoader.c"
	PUTBACK;
	return;
    }
}


XS(XS_ByteLoader_unimport); /* prototype to pass -Wmissing-prototypes */
XS(XS_ByteLoader_unimport)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 156 "ByteLoader.xs"
    filter_del(byteloader_filter);
#line 250 "ByteLoader.c"
	PUTBACK;
	return;
    }
}

#ifdef __cplusplus
extern "C"
#endif
XS(boot_ByteLoader); /* prototype to pass -Wmissing-prototypes */
XS(boot_ByteLoader)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
#if (PERL_REVISION == 5 && PERL_VERSION < 9)
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
    XS_VERSION_BOOTCHECK ;

        (void)newXSproto_portable("ByteLoader::import", XS_ByteLoader_import, file, ";$@");
        (void)newXSproto_portable("ByteLoader::unimport", XS_ByteLoader_unimport, file, ";@");
#if (PERL_REVISION == 5 && PERL_VERSION >= 9)
  if (PL_unitcheckav)
       call_list(PL_scopestack_ix, PL_unitcheckav);
#endif
    XSRETURN_YES;
}

